

// Name definitions
var p1romname;var p2romname;var s1romname;var c1romname;var c2romname;var c3romname;
var c4romname;var c5romname;var c6romname;var c7romname;var c8romname;var m1dromname;
var v1romname;var v2romname;var v3romname;var v4romname;var v5romname;var m1romname;
var p3romname;

// Do actual name generation
function do_name_gen(form, type, input)
{
	var d = "";
	if ((type.slice(0,1) == "c") && (form.addd.checked != "")) d = "d";

	if (((input == ("xxx-" + type + ".bin"))||(form.parsed.value == 1)) && (form.usegen.checked != ""))
	{
		if ((type == "m1d")&&(form.chxbxm1.checked == false))
		{
			type = "m1";
		}

		rom_name = form.name.value + form.sepr.value + type + d + form.ext.value;
	} else
		rom_name = input;

	return rom_name;
}

// List of forms to generate names for
function name_gen(form)
{
	p1romname = do_name_gen(form, "p1", form.p1name.value);
	p2romname = do_name_gen(form, "p2", form.p2name.value);
	p3romname = do_name_gen(form, "p3", form.p3name.value);
	s1romname = do_name_gen(form, "s1", form.s1name.value);
	c1romname = do_name_gen(form, "c1", form.c1name.value);
	c2romname = do_name_gen(form, "c2", form.c2name.value);
	c3romname = do_name_gen(form, "c3", form.c3name.value);
	c4romname = do_name_gen(form, "c4", form.c4name.value);
	c5romname = do_name_gen(form, "c5", form.c5name.value);
	c6romname = do_name_gen(form, "c6", form.c6name.value);
	c7romname = do_name_gen(form, "c7", form.c7name.value);
	c8romname = do_name_gen(form, "c8", form.c8name.value);
	m1dromname = do_name_gen(form, "m1d", form.m1dname.value);
	m1romname = do_name_gen(form, "m1", form.m1name.value);
	v1romname = do_name_gen(form, "v1", form.v1name.value);
	v2romname = do_name_gen(form, "v2", form.v2name.value);
	v3romname = do_name_gen(form, "v3", form.v3name.value);
	v4romname = do_name_gen(form, "v4", form.v4name.value);
	v5romname = do_name_gen(form, "v5", form.v5name.value);
}

// This is for adding 0 before small (less than 1mb) rom sizes in FBA and MAME.
function add_zero_sizes(input)
{
	var zero = "";
	if ((document.gen.picker.value != "nebula") && (input <= eval(1048575))) zero = "0";

	return (zero + toHex(input));
}

// Check for incorrect Hash
function mame_crc(input, begin, end, l)
{
	var output = begin + input + end;
	if (output.length < (begin.length + end.length + l)) output = "NO_DUMP";

	return output;
}

// RomCenter generation (incomplete)
function rc_gen(form, begin, type, name, is_clone)
{
	var output = "";
	if (form["chxbx" + type].checked == true)
	{
		var crc = form[type + "crc"].value;
		if (crc.length < 7) crc = 0;
		output += begin + name + "" + crc + "" + form[type + "size"].value + "";
		if ((is_clone == 1)&&(form["merged" + type].value == 1))
		{
			output += form.parentname.value + "";
			output += form[type + "name"].value;
			return output + "\n";
		} else {

			return output + "neogeo\n";
		}
	}
	return "";
}

// ClrMAMEPro generation (mostly complete)
function clr_gen(form, type, name, is_clone)
{
	var output = "";
	if (form["chxbx" + type].checked != false)
	{
		output += "\trom ( name " + name;
		if ((is_clone != 0)&&(form["merged" + type].value == 1))
		{
			output += " merge " + form[type + "name"].value;
		}
		output += " size " + form[type + "size"].value;
		var crc = form[type + "crc"].value;
		if (crc.length < 7) crc = 0;
		output += " crc " + crc + " )\n";
		return output;
	}
	return "";
}

// For ClrMAMEPro Extras
function clrmxtra(input, i, sz, ln)
{
	var output = 0;

	for (j = 0; j < sz; j++)
	{
		if (input.slice(i+j+ln, i+j+ln+1) == "\n")
		{
			output = input.slice(i+ln, i+j+ln+1);
			output = output.replace(/\"/gi, "");
			return output;
		}
	}
}

function fba_gen(b_spac, name, hexsize, crc, ident, num, end)
{
	return "	{" + b_spac + "\"" + name + "\", 0x" + hexsize + ", " + crc + ", " + ident + "}, //  " + num + " " + end + "\n";
}

  /*-----------------------------------------------------------------------------------------------------*\
  |  I'm not sure who wrote this decimal to hex stuff, but here's the site where I found it:		  |
  |  http://forums.htmlcenter.com/showthread.php?s=4801268acfe664dfc0db51a6ef6cd7d2&postid=2433#post2433  |
  |  Please note that I have made some modifications to the original code.     				  |
  \*-----------------------------------------------------------------------------------------------------*/

function charToHex(i)
{
	if (i == 0) hexChar = '0';
	else if (i == 1) hexChar = '1';
	else if (i == 2) hexChar = '2';
	else if (i == 3) hexChar = '3';
	else if (i == 4) hexChar = '4';
	else if (i == 5) hexChar = '5';
	else if (i == 6) hexChar = '6';
	else if (i == 7) hexChar = '7';
	else if (i == 8) hexChar = '8';
	else if (i == 9) hexChar = '9';
	else if (i ==10) hexChar = 'a';
	else if (i ==11) hexChar = 'b';
	else if (i ==12) hexChar = 'c';
	else if (i ==13) hexChar = 'd';
	else if (i ==14) hexChar = 'e';
	else if (i ==15) hexChar = 'f';
	return hexChar;
}

function toHex(i)
{
	runningTotal = ''
	quotient = Math.floor(eval(i +'/ 16'));
	remainder = eval(i + '-(' + quotient + '* 16)')
	runningTotal += charToHex(remainder);
	while(quotient >= 16)
	{
		savedQuotient = Math.floor(eval(quotient +'/ 16'));
		remainder = eval(quotient + '-(' + savedQuotient + '* 16)');
		runningTotal += charToHex(remainder);
		quotient = savedQuotient;
	}
	return charToHex(quotient) + runningTotal ;
}


